using System;
using IdeaBlade.EntityModel;

namespace IdeaBlade.TestFramework {
  public static class OperationTestTheOpExtensions {

    public static void TestTheOp<T>(
      this EntityQueryOperation<T> op,
      params Action<EntityQueryOperation<T>>[] testActions) {

      TestTheOp(op, String.Empty, testActions);
    }

    public static void TestTheOp<T>(
      this EntityQueryOperation<T> op,
      string failureMessage,
      params Action<EntityQueryOperation<T>>[] testActions) {

      WaitFor.IsCompleted(op);
      WaitFor.Callback(
        () => {
          op.AssertNoQueryFailure();
          foreach (var action in testActions) {
            action(op);
          }
        });
      WaitFor.TestComplete();
    }

    public static void TestTheOp<T>(
      this EntityScalarQueryOperation<T> op,
      params Action<EntityScalarQueryOperation<T>>[] testActions) {
      TestTheOp(op, String.Empty, testActions);
    }

    public static void TestTheOp<T>(
      this EntityScalarQueryOperation<T> op,
      string failureMessage,
      params Action<EntityScalarQueryOperation<T>>[] testActions) {

      WaitFor.IsCompleted(op);
      WaitFor.Callback(
        () => {
          op.AssertNoQueryFailure();
          foreach (var action in testActions) {
            action(op);
          }
        });
      WaitFor.TestComplete();
    }

    public static void TestTheOp(
      this BaseOperation op,
      params Action<object>[] actions) {
      TestTheOp(op, String.Empty, actions);
    }

    public static void TestTheOp(this  BaseOperation op,
      string failureMessage,
      params Action<object>[] testActions) {

      WaitFor.IsCompleted(op);
      WaitFor.Callback(
        () => {
          op.AssertNoOperationFailure();
          foreach (var action in testActions) {
            action(op);
          }
        });
      WaitFor.TestComplete();

    }

  }
}