Imports System.Runtime.Serialization
Imports IdeaBlade.EntityModel

''' <summary>
''' Slice of the Employee class for use in a projection
''' </summary>
<DataContract()>
Public Class EmployeeSlice
    Implements IKnownType

    ' Employee properties
    <DataMember()>
    Public Property EmployeeID() As Integer
    <DataMember()>
    Public Property FirstName() As String
    <DataMember()>
    Public Property LastName() As String

    ' Calculated property
    Public ReadOnly Property FullName() As String
        Get
            Return FirstName & " " & LastName
        End Get
    End Property

    ' Aggregation of values from an Employee navigation property
    <DataMember()>
    Public Property OrderCount() As Integer
End Class
