' (c) Copyright IdeaBlade, Inc. and Microsoft Corporation
' Derived from Microsoft Silverlight User Test Framework// (c) Copyright Microsoft Corporation.
' This source is subject to the Microsoft Public License (Ms-PL).
' Please see http://go.microsoft.com/fwlink/?LinkID=131993 for details.
' All other rights reserved.

Imports System.Threading

Namespace IdeaBlade.TestFramework
  ''' <summary>
  ''' A work item for tests to use which will call the delegate when the work 
  ''' item is executed.
  ''' </summary>
  Public Class CallbackWorkItem
	  Inherits SynchronizedWorkItem
	''' <summary>
	''' Stored void delegate.
	''' </summary>
	Private _action As Action

	''' <summary>
	''' Create a new Callback work item.
	''' </summary>
	''' <param name="callback">Action to execute on Invoke.</param>
	''' <param name="context">
	''' Optional <see cref="SynchronizationContext"/> in which callback should be executed.
	''' </param>
	Public Sub New(ByVal callback As Action, Optional ByVal context As SynchronizationContext = Nothing)
	  _action = callback
	  SyncContext = context
	End Sub


	''' <summary>
	''' Execute the callback.
	''' </summary>
	''' <returns>Whether the work item is complete (which it always is).</returns>
	Public Overrides Function Invoke() As Boolean
	  Send(_action)
	  WorkItemComplete()
	  Return MyBase.Invoke()
	End Function
  End Class
End Namespace