Imports System.Collections.ObjectModel
Imports IdeaBlade.EntityModel
Imports Microsoft.VisualStudio.TestTools.UnitTesting
' ReSharper disable RedundantArgumentName

Namespace IdeaBlade.TestFramework
  ' Desktop .NET specific portion of the DevForce Asynchronous test base class
  <TestClass>
  Partial Public Class DevForceTest
	  Inherits AsyncTestMethodRunner

	''' <summary>
	''' Ensure an EntityManager is pinned to the thread 
	''' of the test's SynchronizationContext.
	''' </summary>
	''' <remarks>
	''' Needed in Desktop; not needed in SL tests where Manager would be created in the SyncContext.
	''' </remarks>
	Protected Sub PinManagerToSyncContextThread(ByVal manager As EntityManager)
	  manager.AuthorizedThreadId = SyncContextThreadId
	End Sub

	Private Sub SetTestClassBase()
	  ' "WaitFor" extension methods refer to this instance on the SyncContext thread.
      EnqueueCallback(Sub() TestClassBase = Me)
	End Sub

	Protected Overridable Sub Log(ByVal message As String)
	  _logCount += 1
	  Debug.WriteLine("*** [{0}] {1}", _logCount, message)
	  _logMessages.Add(message)
	End Sub

	Private _logCount As Integer
	Private ReadOnly _logMessages As New ObservableCollection(Of String)()
  End Class
End Namespace