﻿Imports IdeaBlade.Validation

' General purpose custom verifiers
''' <summary>
''' Ensure that the Guid property value is not the empty Guid
''' </summary>
Public Class NotEmptyGuidVerifier
    Inherits PropertyValueVerifier

    Public Sub New(ByVal entityType As Type, ByVal propertyName As String, Optional ByVal displayName As String = Nothing, Optional ByVal treatEmptyStringAsNull? As Boolean = Nothing)
        MyBase.New(New PropertyValueVerifierArgs(entityType, propertyName, False, displayName, treatEmptyStringAsNull))
    End Sub

    Protected Overrides Function VerifyValue(ByVal itemToVerify As Object, ByVal valueToVerify As Object, ByVal triggerContext As TriggerContext, ByVal verifierContext As VerifierContext) As VerifierResult
        Return New VerifierResult((Not Equals(valueToVerify, Guid.Empty)))
    End Function
End Class
