' ReSharper disable RedundantUsingDirective
Imports System.ComponentModel ' keep for SL
' ReSharper restore RedundantUsingDirective
Imports System.Reflection
Imports Microsoft.Silverlight.Testing
Imports Microsoft.VisualStudio.TestTools.UnitTesting
Imports AdvancedNorthwindModel

' ReSharper disable InconsistentNaming
' ReSharper disable RedundantDefaultFieldInitializer
' ReSharper disable RedundantArgumentName

Namespace WorkingWithEntities.BaseClassTests
	<TestClass>
	Public Class When_entities_derived_from_EntityBase
		<TestInitialize>
		Public Sub TestInitialize()
			manager = New AdvancedNorthwindManager(shouldConnect:= False)
		End Sub

		<TestMethod, Tag("EntityBase")>
		Public Sub then_can_access_EntityTypeName()
			Dim cust = New Customer()
			Assert.AreEqual("Customer", GetEntityTypeName(cust))
		End Sub

		<TestMethod, Tag("EntityBase")>
		Public Sub then_Customer_is_an_Actor()
			Dim isActor = GetType(Actor).IsAssignableFrom(GetType(Customer))
			Assert.IsTrue(isActor, "Customer should be an Actor")
		End Sub

		<TestMethod, Tag("EntityBase")>
		Public Sub then_Order_is_not_an_Actor()
			Dim isActor = GetType(Actor).IsAssignableFrom(GetType(Order))
			Assert.IsFalse(isActor, "Order should not be an Actor")
		End Sub

		#Region "Helpers"

		Protected Function GetEntityTypeName(ByVal entity As EntityBase) As String
			Dim propInfo = GetType(Customer).GetProperty("EntityTypeName", BindingFlags.NonPublic Or BindingFlags.Instance)
			Return TryCast(propInfo.GetValue(entity, Nothing), String)
		End Function
		Protected manager As AdvancedNorthwindManager
		Protected testCustomer As Customer

		#End Region

	End Class

End Namespace